#!/usr/local/bin/python3

import subprocess
import pandas as pd
import statistics

#https://fish-evol.org/GMT_ji.html

# タブ区切りのテキストファイルを読み込み、データフレームに格納
#file_white_plots = '150_cruseAll_lat_lon_kawakami.txt'
#file_red_plots = '150_sampleID_lat_lon_kawakami.txt'
file_white_plots = '150_cruseAll_lat_lon_northSea.txt'
file_red_plots = '150_sampleID_lat_lon_northSea.txt'
#file_white_plots = '150_cruseAll_lat_lon_kuroshio.txt'
#file_red_plots = '150_sampleID_lat_lon_kuroshio.txt'
#file_white_plots = '150_cruseAll_lat_lon_3c.txt'
#file_red_plots = '150_sampleID_lat_lon_3c.txt'
#file_white_plots = '150_cruseAll_lat_lon_2c.txt'
#file_red_plots = '150_sampleID_lat_lon_2c.txt'



df = pd.read_csv(file_white_plots, delimiter='\t', header=None, names=['Longitude', 'Latitude', 'Station'])

# Latitude 列から数値以外の値を除外する
df = df[pd.to_numeric(df['Latitude'], errors='coerce').notnull()]

# Latitude 列あるいは Longitude 列が数値以外の行を除外する
df['Latitude'] = pd.to_numeric(df['Latitude'])
df['Longitude'] = pd.to_numeric(df['Longitude'])

# Latitude 列と Longitude 列を数値に変換する
df['Latitude'] = pd.to_numeric(df['Latitude'])
df['Longitude'] = pd.to_numeric(df['Longitude'])

# 値が 0 の行を除外する
df = df[(df['Latitude'] != 0) & (df['Longitude'] != 0)]

mean_latitude = df['Latitude'].mean()
median_latitude = statistics.median(df['Latitude'])
#print("mean_latitude", mean_latitude)
#exit()
#mean_latitude = 58
#mean_latitude = 55.829205
#mean_latitude = 54
#mean_latitude = 40
#mean_latitude = 0
#mean_latitude = -50
#mean_latitude = -55.829205

list_longitudes = []
for longitude in df['Longitude']:
    #print("longitude1", longitude)
    #if float(longitude) < -90 :
    if longitude < -90 :
        longitude = 360 + longitude
        #print("longitude2", longitude)
    #print("")
    #list_longitudes.append(float(longitude))
    list_longitudes.append(longitude)
median_longitude = statistics.median(list_longitudes)
mean_longitude = sum(list_longitudes) / len(list_longitudes)


print("mean_latitude", mean_latitude)
print("mean_longitude", mean_longitude)
#exit()
#mean_longitude = -1.859285

####
#ido_keido = "125/139/-35/-26"
#map_type  = "wide"
#R_grdimage_region = "110/168/-54/-22"  # "110/168/-56/-22"


range_longetude = df['Longitude'].max() - df['Longitude'].min()
#print("range_longetude", range_longetude)
#exit()

if 50 <= range_longetude:
    map_type  = "kawakami"
elif 16 <= range_longetude and range_longetude < 50:
    map_type  = "japan"
else:
    map_type  = "kuroshio"


if map_type == "kawakami":
    psbasemap_B = "a10f10g10"
    west_wide = mean_longitude - 100
    east_wide = mean_longitude + 100
    if 58 < mean_latitude:
        map_type_A = "kawakami_over58"
        #print("## 1 ##")
        north_wide = mean_latitude + 20
        south_wide = mean_latitude - 35
    elif 20 < mean_latitude and mean_latitude <= 58:
        map_type_A = "kawakami_20_58"
        north_wide = mean_latitude + 25
        south_wide = mean_latitude - 25

    elif mean_latitude < -20 and mean_latitude <= 20:
        map_type_A = "kawakami_-20_20"
        north_wide = mean_latitude + 25
        south_wide = mean_latitude - 25

    elif -58 < mean_latitude and mean_latitude <= -20:
        map_type_A = "kawakami_-58_-20"
        north_wide = mean_latitude + 25
        south_wide = mean_latitude - 25

    elif mean_latitude <= -58:
        map_type_A = "kawakami_under-58"
        north_wide = mean_latitude + 35
        south_wide = mean_latitude - 20

elif map_type == "japan":
    psbasemap_B = "a1f1g1"
    map_type_A = "japan_A"
    north_wide = mean_latitude + 17
    south_wide = mean_latitude - 17
    west_wide = mean_longitude - 25
    east_wide = mean_longitude + 25
else:
    psbasemap_B = "a1f1g1"
    map_type_A = "kuroshio_A"
    north_wide = mean_latitude + 6
    south_wide = mean_latitude - 5
    west_wide = mean_longitude - 8
    east_wide = mean_longitude + 9

print("############## map_type_A #############")
print(map_type_A)
print("#######################################")
#exit()

R_grdimage_region = str(west_wide) + "/" + str(east_wide) + "/" + str(south_wide) + "/" + str(north_wide)  # "110/168/-56/-22"

#R_grdimage_region = "124/140/25/36" #"125/139/26/35"
#R_grdimage_region = "125/139/26/35"
#print("R_grdimage_region", R_grdimage_region)
#exit()

############################

line_mkdir = "mkdir outfiles_py"
#print("line_mkdir", line_mkdir, "<br>")
subprocess.call(line_mkdir, shell=True)


#gmt makecpt -Chaxby -T-6000/0/10 -Z > outfiles_py/050_haxby_area.cpt
line_makecpt = "gmt makecpt -Chaxby -T-6000/0/10 -Z > outfiles_py/050_haxby_area.cpt"
#print("line_makecpt", line_makecpt, "<br>")
subprocess.call(line_makecpt, shell=True)

#gmt grdimage ~/ETOPO1_Ice_g_gmt4.grd -R125/139/26/35 -JM24c  -Coutfiles/050_haxby_area.cpt -X1c -Y1c -K >> outfiles_py/150map.ps
#gmt grdimage ~/ETOPO1_Ice_g_gmt4.grd -R125/139/-35/-26 -JM24c  -Coutfiles/050_haxby_area.cpt -X1c -Y1c -K >> outfiles_py/150map.ps
#line_grdimage = "gmt grdimage ~/ETOPO1_Ice_g_gmt4.grd -R125/139/26/35 -JM24c  -Coutfiles_py/050_haxby_area.cpt -X1c -Y1c -K >> outfiles_py/150map.ps"
line_grdimage = "gmt grdimage ~/ETOPO1_Ice_g_gmt4.grd -R" + R_grdimage_region + " -JM24c  -Coutfiles_py/050_haxby_area.cpt -X1c -Y1c -K >> outfiles_py/150map.ps"
#print("line_grdimage", line_grdimage, "<br>")
subprocess.call(line_grdimage, shell=True)

#gmt grdcontour ~/ETOPO1_Ice_g_gmt4.grd -R125/139/26/35 -JM24c -C500 -A500 -L-6000/-0 -W0.1 -K -O -V >> outfiles_py/150map.ps
#gmt grdcontour ~/ETOPO1_Ice_g_gmt4.grd -R125/139/-35/-26 -JM24c -C500 -A500 -L-6000/-0 -W0.1 -K -O -V >> outfiles_py/150map.ps
#line_grdcontour = "gmt grdcontour ~/ETOPO1_Ice_g_gmt4.grd -R125/139/26/35 -JM24c -C500 -A500 -L-6000/-0 -W0.1 -K -O -V >> outfiles_py/150map.ps"
line_grdcontour = "gmt grdcontour ~/ETOPO1_Ice_g_gmt4.grd -R" + R_grdimage_region + " -JM24c -C500 -A500 -L-6000/-0 -W0.1 -K -O -V -^ >> outfiles_py/150map.ps"
#print("line_grdcontour", line_grdcontour, "<br>")
subprocess.call(line_grdcontour, shell=True)

#gmt pscoast -R125/139/26/35 -JM24c -Di -Ggray -W0.1,black -K -O -V >> outfiles_py/150map.ps
#gmt pscoast -R125/139/-35/-26  -JM24c -Di -Ggray -W0.1,black -K -O -V >> outfiles_py/150map.ps
#line_pscoast = "gmt pscoast -R125/139/26/35 -JM24c -Di -Ggray -W0.1,black -K -O -V >> outfiles_py/150map.ps"
line_pscoast = "gmt pscoast -R" + R_grdimage_region + " -JM24c -Di -Ggray -W0.1,black -K -O -V >> outfiles_py/150map.ps"
#print("line_pscoast", line_pscoast, "<br>")
subprocess.call(line_pscoast, shell=True)

#gmt psscale -D24.5/5/10/0.5 -Coutfiles/050_haxby_area.cpt -Bf1000a2000 -K -O -V >> outfiles_py/150map.ps
line_psscale = "gmt psscale -D24.5/5/10/0.5 -Coutfiles_py/050_haxby_area.cpt -Bf1000a2000 -K -O -V >> outfiles_py/150map.ps"
print("line_psscale", line_psscale, "<br>")
subprocess.call(line_psscale, shell=True)

#gmt psbasemap -R125/139/26/35 -JM24c -Ba1f1g1 -BWSne+tKuroshio-region -K -O -V >> outfiles_py/150map.ps
#gmt psbasemap -R125/139/-35/-26 -JM24c -Ba1f1g1 -BWSne+tKuroshio-region -K -O -V >> outfiles_py/150map.ps
#line_psbasemap = "gmt psbasemap -R125/139/26/35 -JM24c -Ba1f1g1 -BWSne+tKuroshio-region -K -O -V >> outfiles_py/150map.ps"

#if map_type == "wide":
#    #psbasemap_B = "a10f10g10"
#    line_psbasemap = "gmt psbasemap -R" + R_grdimage_region + " -JM24c -Ba10f10g10 -BWSne+tLarge-type -K -O -V >> outfiles_py/150map.ps"
#else:
#    #psbasemap_B = "a1f1g1"
#    line_psbasemap = "gmt psbasemap -R" + R_grdimage_region + " -JM24c -Ba1f1g1 -BWSne+tLarge-type -K -O -V >> outfiles_py/150map.ps"
line_psbasemap = f"gmt psbasemap -R{R_grdimage_region} -JM24c -B{psbasemap_B} -BWSne+tLarge-type -K -O -V >> outfiles_py/150map.ps"

#print("line_psbasemap", line_psbasemap, "<br>")
subprocess.call(line_psbasemap, shell=True)
#exit()

#psxy 1
#gmt psxy 150_cruseAll_lat_lon.txt -R -JM -Sc0.40 -W1 -Gwhite -K -O -V >> outfiles_py/150map.ps
line_psxy = f"gmt psxy {file_white_plots} -R -JM -Sc0.40 -W1 -Gwhite -K -O -V >> outfiles_py/150map.ps"
print("line_psxy", line_psxy, "<br>")
subprocess.call(line_psxy, shell=True)

#gmt pstext 150_cruseAll_lat_lon.txt -R125/139/26/35 -JM24c -F+f12p,Helvetica,-=0.5p,black+jBL -K -O -V >> outfiles_py/150map.ps
#gmt pstext 150_cruseAll_lat_lon.txt -R125/139/-35/-26 -JM24c -F+f12p,Helvetica,-=0.5p,black+jBL -K -O -V >> outfiles_py/150map.ps
#line_pstext = "gmt pstext 150_cruseAll_lat_lon.txt -R125/139/26/35 -JM24c -F+f12p,Helvetica,-=0.5p,black+jBL -K -O -V >> outfiles_py/150map.ps"
line_pstext = f"gmt pstext {file_white_plots} -R" + R_grdimage_region + " -JM24c -F+f12p,Helvetica,-=0.5p,black+jBL -K -O -V >> outfiles_py/150map.ps"
#print("line_pstext", line_pstext, "<br>")
subprocess.call(line_pstext, shell=True)

#psxy 2
#gmt psxy 150_sampleID_lat_lon.txt -R -JM -Sc0.40 -W1 -Gred -O -V >> outfiles_py/150map.ps
line_psxy = f"gmt psxy {file_red_plots} -R -JM -Sc0.40 -W1 -Gred -O -V >> outfiles_py/150map.ps"
#print("line_psxy", line_psxy, "<br>")
subprocess.call(line_psxy, shell=True)

#psconvert1
#gmt psconvert outfiles_py/150map.ps -P -Tg -E200 -V
line_psconvert = "gmt psconvert outfiles_py/150map.ps -P -Tg -E200 -V"
#print("line_psconvert", line_psconvert, "<br>")
subprocess.call(line_psconvert, shell=True)

#psconvert2
#gmt psconvert outfiles_py/150map.ps -P -Tf -E200
line_psconvert = "gmt psconvert outfiles_py/150map.ps -P -Tf -E200"
#print("line_psconvert", line_psconvert, "<br>")
subprocess.call(line_psconvert, shell=True)

print("map_type_A", map_type_A)